# BranchAndPrune.jl

This package aims at providing an interface for branch and prune search in Julia.

## Branch and prune

A branch and prune algorithm has the following general structure:

1. Consider one region of the search space.
2. Determine status of this search region, with three possible outcomes:
   1. The region does not contain anything of interest. In this case discard the region (*prune* it).
   2. The region is in a state that does not require further processing (for example a given tolerance has been met). In this case it is stored.
   3. None of the above. In this case, the region is bisected and each of the subregions created is added to the pool of regions to be considered (creating new *branches* for the search).
3. Go back to 1.

Also this was developped to meet the need of the [`IntervalRootFinding.jl`](https://github.com/JuliaIntervals/IntervalRootFinding.jl) package, and as such it constitutes a concrete example of possible usage.


## Usage example

As an example we are looking for zero of monotonic functions, `f(x) = 0`.

We work with tuple of numbers `(a, b)` to represent intervals.

First we define the `process` function. The logic is as follow
- if the image of both side of the interval have the same sign, then the interval does not contain a solution (since `f` is monotonic) and we discard the interval.
- if the size of the interval is small enough, we store it.
- otherwise, we bisect it.

In all cases, we do not modify the interval when processing it.

```jl
using BranchAndPrune

function process(f, (a, b), tol = 1e-8)
    ya = f(a)
    yb = f(b)
    # If both have the same sign their product is positive
    if ya * yb > 0
        return :prune, (a, b)
    elseif b - a < tol
        return :store, (a, b)
    else
        return :branch, (a, b)
    end
end
```

Then we define how an interval is bisected.

```jl
function bisect((a, b))
    m = (a + b)/2  # The midpoint
    return (a, m), (m, b)
end
```

Note the difference between `process` and `bisect`. `bisect` only act on the search regions, independantly of the problem we are trying to solve, while `process` is responsible for everything related to actually solving the problem (by looking at the behavior of `f` in the example).

Finally we perform the search, by defining the function of interest and the search object, and passing it to `bpsearch`.

```jl
f(x) = x/3 + 5  # Exact solution is -15
search = BranchAndPruneSearch(BreadthFirst, X -> process(f, X), bisect, (-30.0, 20.0))
bpsearch(search)
```

Returning a correct enclosure of the solution

```
BranchAndPruneResult
 converged: true
 initial region: (-30.0, 20.0)
 final regions:
  (-15.00000000349246, -14.999999997671694)
```

Using a callback it is possible to stop the iteration early

```jl
sol = bpsearch(search ; callback = state -> state.iteration >= 10)
```

In this case no region hit the finalized state, and the search is considered unconverged.

```jl
julia> sol = bpsearch(search ; callback = state -> state.iteration >= 25)
BranchAndPruneResult
 converged: false
 initial region: (-30.0, 20.0)
 final regions:

 unfinished regions:
  (-15.009765625, -15.003662109375)
  (-15.003662109375, -14.99755859375)
  (-14.99755859375, -14.9853515625)
```

The tree representing the current state of the search can be examined.

```jl
julia> sol.tree
Branching
├─ Branching
│  ├─ (:working, (-15.009765625, -15.003662109375))
│  └─ (:working, (-15.003662109375, -14.99755859375))
└─ (:working, (-14.99755859375, -14.9853515625))
```

Using a `DepthFirst` order instead, we see a different intermediate result and tree.
As expected, using a depth first search produces a much deeper tree.

```jl
julia> search = BranchAndPruneSearch(DepthFirst, X -> process(f, X), bisect, (-30.0, 20.0))
BranchAndPruneSearch{DepthFirst, Tuple{Float64, Float64}, var"#91#92", typeof(bisect)}(var"#91#92"(), bisect, (-30.0, 20.0))

julia> sol = bpsearch(search ; callback = state -> state.iteration >= 25)
BranchAndPruneResult
 converged: false
 initial region: (-30.0, 20.0)
 final regions:

 unfinished regions:
  (-30.0, -17.5)
  (-17.5, -15.9375)
  (-15.9375, -15.15625)
  (-15.15625, -15.05859375)
  (-15.05859375, -15.009765625)
  (-15.009765625, -15.003662109375)
  (-15.003662109375, -15.0006103515625)
  (-15.0006103515625, -14.999847412109375)
  (-14.999847412109375, -14.99908447265625)


julia> sol.tree
Branching
├─ (:working, (-30.0, -17.5))
└─ Branching
   ├─ (:working, (-17.5, -15.9375))
   └─ Branching
      ├─ (:working, (-15.9375, -15.15625))
      └─ Branching
         ├─ (:working, (-15.15625, -15.05859375))
         └─ Branching
            ├─ (:working, (-15.05859375, -15.009765625))
            └─ Branching
               ⋮
```

"""
    BPNode(status, region, parent, is_left_child, left_child, right_child)

Node of a binary tree designed for branch and prune search.
It represents a search region and its status.

Its status is one of
- `:working`: for a leaf that need further processing.
- `:final`: for a leaf in its final state.
- `:branching`: for an intermediate node. In this case the data about the
    represented region is not stored in the node, but in its descendents.
"""
mutable struct BPNode{REGION}
    status::Symbol
    region::Union{Nothing, REGION}
    parent::Union{Nothing, BPNode{REGION}}
    is_left_child::Bool
    left_child::Union{Nothing, BPNode{REGION}}
    right_child::Union{Nothing, BPNode{REGION}}
end

function BPNode(status, region, parent, side)
    node = BPNode(status, region, parent, side == :left, nothing, nothing)
    if !isnothing(parent)
        parent[side] = node
    end
    return node
end

function Base.show(io::IO, node::BPNode)
    print(io, "BPNode($(node.status), $(node.region))")
end

Base.show(io::IO, ::MIME"text/plain", node::BPNode) = print_tree(io, node)

function Base.getindex(node::BPNode, side::Symbol)
    side == :left && return node.left_child
    side == :right && return node.right_child
    throw(ArgumentError("BPNOde can only be indexed with :left or :right"))
end

function Base.setindex!(node::BPNode, child::BPNode, side::Symbol)
    side == :left && return (node.left_child = child)
    side == :right && return (node.right_child = child)
    throw(ArgumentError("BPNOde can only be indexed with :left or :right"))
end

"""
    prune!(node::BPNOde ; squash = true)

Remove the node from the tree, and recursively all branching nodes
that are left without descendant.

If `squash` is true, modify the tree to skip intermediate branching node
with a single descendant.
"""
function prune!(node::BPNode ; squash = true)
    parent = node.parent

    if isnothing(parent)
        node.region = nothing
        node.status = :empty
        node.left_child = nothing
        node.right_child = nothing
        return
    end

    if node.is_left_child
        isnothing(parent.right_child) && return prune!(parent)
        parent.left_child = nothing
    else
        isnothing(parent.left_child) && return prune!(parent)
        parent.right_child = nothing
    end
    squash && return squash_node!(parent)
end

squash_node!(::Nothing) = nothing

function squash_node!(node::BPNode)
    parent = node.parent
    isnothing(parent) && return
    child = only(children(node))

    if node.is_left_child
        parent.left_child = child
        child.is_left_child = true
        child.parent = parent
    else
        parent.right_child = child
        child.is_left_child = false
        child.parent = parent
    end
end

regions(tree::BPNode) = vcat(unfinished_regions(tree), finished_regions(tree))
finished_regions(tree::BPNode{REGION}) where REGION = REGION[leaf.region for leaf in Leaves(tree) if leaf.status == :final]
unfinished_regions(tree::BPNode{REGION}) where REGION = REGION[leaf.region for leaf in Leaves(tree) if leaf.status == :working]

# AbstractTree.jl API
function AbstractTrees.children(node::BPNode{REGION}) where REGION
    if isnothing(node.left_child)
        isnothing(node.right_child) && return BPNode{REGION}[]
        return [node.right_child]
    else
        isnothing(node.right_child) && return [node.left_child]
        return [node.left_child, node.right_child]
    end
end

AbstractTrees.nodevalue(node::BPNode) = (node.status, node.region)

AbstractTrees.ParentLinks(::Type{<:BPNode}) = StoredParents()
AbstractTrees.parent(node::BPNode) = node.parent

AbstractTrees.NodeType(::Type{<:BPNode}) = HasNodeType()
AbstractTrees.nodetype(::Type{T}) where {T <: BPNode} = T

function AbstractTrees.printnode(io::IO, node::BPNode)
    if node.status == :branching
        print(io, "Branching")
    else
        print(io, nodevalue(node))
    end
end

"""
    SearchOrder

Abstract type representing the order of processing during a branch and
prune search.

For custom search orders following methods must be implemented:
- `pop!(so::SearchOrder)`: return the next leaf to be processed.
    Return `nothing` when the search is done.
- `push!(so::SearchOrder, leaf::BPNode)`: add a leaf to the set of leaves to be
    processed.

The object is initialized by giving it the root node of the search tree,
as `SearchOrder(root::BPNode)`.
"""
abstract type SearchOrder end

struct DepthFirst{REGION} <: SearchOrder
    working_leaves::Vector{BPNode{REGION}}
end

DepthFirst(root::BPNode) = DepthFirst([root])

struct BreadthFirst{REGION} <: SearchOrder
    working_leaves::Vector{BPNode{REGION}}
end

BreadthFirst(root::BPNode) = BreadthFirst([root])

mutable struct ChangingOrder{REGION} <: SearchOrder
    working_leaves::Vector{BPNode{REGION}}
    next::Int 
end

ChangingOrder(root::BPNode) = ChangingOrder([root], 1)
set_next!(so::ChangingOrder, i::Int) = (so.next = i)

"""
    pop!(::SearchOrder)

Return the next leaf that will be processed.

Can modify the internal state of the SearchOrder.

Must return `nothing` if there is no more data to process.

Must be define for custom search orders.
"""
Base.pop!(so::BreadthFirst) = isempty(so.working_leaves) ? nothing : popfirst!(so.working_leaves)
Base.pop!(so::DepthFirst) = isempty(so.working_leaves) ? nothing : pop!(so.working_leaves)
function Base.pop!(so::ChangingOrder)
    isempty(so.working_leaves) && return nothing
    next = so.working_leaves[so.next]
    deleteat!(so.working_leaves, so.next)
    so.next = 1
    return next
end 

"""
    push!(::SearchOrder, leaf::BPNode)

Add a leaf to the set of nodes that need to be processed.

Can modify the internal state of the SearchOrder.

Must be define for custom search orders.
"""
Base.push!(so::Union{DepthFirst, BreadthFirst, ChangingOrder}, leaf::BPNode) = push!(so.working_leaves, leaf)

"""
    BranchAndPruneSearch(S, process, bisect, initial_region)

Branch and prune search, using the search order `S` on the given initial region.
It works by recursively bisecting the regions of search with `bisect` until
all regions are found satisfactory according to `process`.
Build a binary tree relating the regions to each other as the search progress.

`process` and `bisect` both take a single region as an argument.

`process` must return an action to perform and the region on which
to perform it. The possible actions are
- `:store`: the region is considered as final, is stored, and is not
    further processed.
- `:branch`: the element is bisected and each of the two resulting part
    are processed independently.
- `:prune`: the element is discarded from the tree.
    If it is the last descendant of a branch, the whole branch is pruned
    from the tree.
    The intermediate nodes with a single descendant are also removed from the tree.
The initial region can be returned unchanged if no refinement is possible at
this stage.

`bisect` is used when a region is marked to be branched.
It must return two subregions of the original one, and of the same type.

`BranchAndPruneSearch` objects are iterable, exhausting the iterable
performs the full search.

WARNING
By default, the search only ends when all remaining regions are given the
directive `:store` by the process function.
For stopping based on different criterion, either manually break the iteration
loop or use `bpsearch(search ; callback)` with a custom callback function.
"""
struct BranchAndPruneSearch{S, REGION, F, G}
    process::F
    bisect::G
    initial_region::REGION
end

function BranchAndPruneSearch(S, process::F, bisect::G, initial_region::R) where {F, G, R}
    BranchAndPruneSearch{S, R, F, G}(process, bisect, initial_region)
end

Base.eltype(::Type{BPS}) where {S, REGION, BPS <: BranchAndPruneSearch{S, REGION}} = SearchState{S, REGION}
Base.IteratorSize(::Type{BPS}) where {BPS <: BranchAndPruneSearch} = Base.SizeUnknown()

"""
    SearchState{S, REGION}

State of a search by branch and prune.

Field
=====
- `search_order``::SearchOrder : The order in which the search is performed.
    Contains information about the state of the search.
    See `SearchOrder` for more details.
- `tree`::BPNode{REGION} : The current binary tree representing the search.
- `iteration`::Int
"""
struct SearchState{S, REGION}
    search_order::S
    tree::BPNode{REGION}
    iteration::Int
end

function SearchState(S, initial_region::REGION) where REGION
    root = BPNode(:working, initial_region, nothing, :left)
    return SearchState(S(root), root, 1)
end

regions(state::SearchState) = regions(state.tree)
unfinished_regions(state::SearchState) = [leaf.region for leaf in state.search_order.working_leaves]
finished_regions(state::SearchState) = finished_regions(state.tree)

function Base.show(io::IO, state::SearchState{S, REGION}) where {S, REGION}
    println(io, """
    SearchState{$S, $REGION}
      iteration: $(state.iteration)
      $(length(unfinished_regions(state.tree))) regions being processed""")
    for (i, region) in enumerate(unfinished_regions(state))
        println(io, "    $region")

        if i == 10
            println("        ⋮")
        end
    end

    println(io, "  $(length(finished_regions(state.tree))) finalized regions")
    for (i, region) in enumerate(finished_regions(state))
        println(io, "    $region")
        if i == 10
            println("        ⋮")
        end
    end
end

function Base.iterate(
        bp::BranchAndPruneSearch{S},
        state = SearchState(S, bp.initial_region)) where S

    search = state.search_order

    node = pop!(search)
    isnothing(node) && return nothing

    action, region = bp.process(node.region)
    if action == :store
        node.region = region
        node.status = :final
    elseif action == :branch
        left_data, right_data = bp.bisect(region)
        node.region = nothing
        node.status = :branching
        node.left_child = BPNode(:working, left_data, node, :left)
        node.right_child = BPNode(:working, right_data, node, :right)
        push!(search, node.right_child)
        push!(search, node.left_child)
    elseif action == :prune
        prune!(node)
    else
        error("process function for the search return " *
              "unknown action :$action for region of type $(typeof(region)). " *
              "Valid actions are :store, :branch and :prune.")
    end

    new_state = SearchState(
        state.search_order,
        state.tree,
        state.iteration + 1
    )
    return new_state, new_state
end

"""
    BranchAndPruneResult

Type representing the result of a branch and prune search.

Fields
======
- `search_order::SearchOrder`
- `initial_region`
- `tree::BPNode`: Root of the search tree constructed during the search.
- `final_regions`: Vector of all the regions that have been labelled with `:store`
    during the search.
- `unfinished_regions`: Vector of all the regions that have been produced by
    bisection but never processed.
    Non empty only if the search is stopped early.
- `converged::Bool`: Whether the search has run up to the end.
"""
struct BranchAndPruneResult{S, REGION}
    search_order::S
    initial_region::REGION
    tree::BPNode{REGION}
    final_regions::Vector{REGION}
    unfinished_regions::Vector{REGION}
    converged::Bool
end

function BranchAndPruneResult(
        search_order,
        initial_region::REGION,
        tree::BPNode{REGION}) where REGION

    return BranchAndPruneResult(
        search_order,
        initial_region,
        tree,
        finished_regions(tree),
        unfinished_regions(tree),
        isempty(unfinished_regions(tree))
    )
end

function padded_string(val  ; padding = 1, skip = 0)
    buffer = IOBuffer()
    show(buffer, MIME"text/plain"(), val)
    s = String(take!(buffer))
    pad = " "^padding
    lines = split(s, "\n")[1 + skip:end]
    return pad * join(lines, "\n" * pad)
end

function Base.show(io::IO, ::MIME"text/plain", res::BranchAndPruneResult)
    ctx = IOContext(io, :compact => true)
    println(io, "BranchAndPruneResult")
    println(io, " converged: $(res.converged)")
    print(io, " initial region: ")
    show(ctx, MIME"text/plain"(), res.initial_region)
    println(io)
    println(io, " final regions:\n", padded_string(res.final_regions ; skip = 1))
    if !res.converged
        println(io, " unfinished regions:\n", padded_string(res.unfinished_regions ; skip = 1))
    end
end

"""
    bpsearch(bp::BranchAndPruneSearch ; callback::Function)

Perform a branch and prune search and return its result as a BranchAndPruneResult.

A callback function can be given, which is called on the search state
at every iteration.
It must have signature `callback(state::SearchState)::Bool`.
If it return `true` the searched is stopped and return.
"""
function bpsearch(
        bp::BranchAndPruneSearch ;
        callback = (state -> false))
    endstate = nothing

    for state in bp
        endstate = state
        callback(state) && break
    end

    tree = endstate.tree

    # Remove the root node if it has a single child
    if length(children(tree)) == 1
        tree = only(children(tree))
        tree.parent = nothing
    end

    return BranchAndPruneResult(
        endstate.search_order,
        bp.initial_region,
        tree
    )
end

@testset "search.jl" begin
    # 23 in a sorted list
    function process(list)
        if length(list) == 1
            only(list) == 23 && return :store, list
            return :prune, list
        end

        if last(list) < 23 || first(list) > 23
            return :prune, list
        end

        return :branch, list
    end

    function bisect(list)
        mid = div(length(list), 2)
        return list[1:mid], list[(mid+1):end]
    end

    a = [1, 2, 4, 9, 10, 11, 17, 22, 23, 29, 37, 102]
    
    for SearchOrder in (BreadthFirst, DepthFirst)
        search = BranchAndPruneSearch(BreadthFirst, process, bisect, a)
        res = bpsearch(search)

        @test res.converged == true
        @test length(res.final_regions) == 1
        @test only(res.final_regions)[1] == 23
        @test isempty(res.unfinished_regions)
    end
end

module BranchAndPrune

using AbstractTrees

include("tree.jl")
export regions, finished_regions, unfinished_regions

include("search_order.jl")
export SearchOrder, BreadthFirst, DepthFirst, ChangingOrder
export push!, pop!, set_next!

include("search.jl")
export BranchAndPruneSearch, SearchState, BranchAndPruneResult, bpsearch

end  # module

@testset "tree.jl" begin
    #= Tests on a simple tree

          (1)
         /   \
       (2)   (8)
      /  \     \
    (3)  (5)   (9)
     |   | \     \
    (4) (6) (7)  (10)
    =#

    root = BPNode(:branching, 1, nothing, :left)
    n2 = BPNode(:branching, 2, root, :left)
    n3 = BPNode(:branching, 3, n2, :left)
    n4 = BPNode(:final, 4, n3, :left)
    n5 = BPNode(:branching, 5, n2, :right)
    n6 = BPNode(:final, 6, n5, :left)
    n7 = BPNode(:final, 7, n5, :right)
    n8 = BPNode(:branching, 8, root, :right)
    n9 = BPNode(:branching, 9, n8, :right)
    n10 = BPNode(:final, 10, n9, :right)

    # Check that printing does not error
    io = IOBuffer()
    println(io, root)

    # Check the tree interface
    @test length(collect(Leaves(root))) == 4
    @test length(collect(PreOrderDFS(root))) == 10

    # Test other functions
    @test length(children(n5)) == 2
    @test length(children(n9)) == 1
    @test length(children(n7)) == 0

    squash_node!(n9)
    @test n8.right_child === n10

    prune!(n7, squash = false)
    @test length(children(n5)) == 1
    
    prune!(n4, squash = true)
    @test root.left_child === n5
end

@testset "search_order.jl" begin
    #= Tests on a simple tree

          (1)
         /   \
       (2)   (5)
      /  \
    (3)  (4)
    =#

    root = BPNode(:branching, 1, nothing, :left)
    n2 = BPNode(:branching, 2, root, :left)
    n3 = BPNode(:working, 3, n2, :left)
    n4 = BPNode(:working, 4, n2, :right)
    n5 = BPNode(:working, 5, root, :right)

    depth_first = DepthFirst(n5)
    push!(depth_first, n4)
    push!(depth_first, n3)
    @test pop!(depth_first) == n3
    @test pop!(depth_first) == n4
    @test pop!(depth_first) == n5
    @test isnothing(pop!(depth_first))

    breadth_first = BreadthFirst(n5)
    push!(breadth_first, n4)
    push!(breadth_first, n3)
    @test pop!(breadth_first) == n5
    @test pop!(breadth_first) == n4
    @test pop!(breadth_first) == n3
    @test isnothing(pop!(breadth_first))

    changing = ChangingOrder(n5)
    push!(changing, n4)
    push!(changing, n3)
    set_next!(changing, 2)
    @test pop!(changing) == n4
end
